
# Copyright (C) Johan Ceuppens 2015
# Copyright (C) Johan Ceuppens 2011
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *

import random
from time import *
 
from bgoverlay import *
from meter import *
from taskbar import *
from player import *
from maproom1 import *

class Game:
    "Main function"
    def __init__(self):
        pygame.init()
        pygame.font.init()
        self.screen = pygame.display.set_mode((640, 400))
        self.font = pygame.font.SysFont("Times", 14)
        self.font2 = pygame.font.SysFont("Coutier", 36)
        self.font3 = pygame.font.SysFont("Vera", 52)
        blankimage = pygame.image.load('./pics/blank.png').convert()
        titleimage = pygame.image.load('./pics/titlescreen.png').convert()
        gameover = 0
        while gameover == 0:
            pygame.display.update()
            self.screen.blit(titleimage, (0,0))
            sleep(0.01)
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    gameover = 1
                if event.type == pygame.MOUSEBUTTONDOWN:
                    gameover = 1

            
        gameover = 0

        ###self.heartmeter = Meter()

        pygame.key.set_repeat(10,100)
        ####pygame.key.set_repeat(1000,1000)
	self.roomnumber = 1

	self.player = Player(280,199)
        self.room = Maproom1(0,0,2000,400)
	self.bgoverlay = BGOverlay(0,0)
	self.taskbar = Taskbar(self.screen, self.font2, self.player)

        gameflag = 0
        while gameover == 0:
            self.player.h = 72 # NOTE: for ducking, FIXME 48
            sleep(0.01)
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
            	    self.keydown = 1
                    # self.player 1 key controls
                    
                    if event.key == K_x:
                        self.talker = self.player.talk(self)
                    elif event.key == K_z:
                        self.player.fight(self.room,self,self.player)
                    elif event.key == K_c:
                        self.player.cast(self)
                    elif event.key == K_p:
                        self.player.deitypower(self)
                    elif event.key == K_DOWN:
                        self.keydown = 2
                        
                        #FIXME keydown = 2
                        #self.room.moveup()    
                    elif event.key == K_RIGHT:
                        self.room.moveright()
                        self.room.direction = "left"
                        self.player.direction = self.player.RIGHT 
                    elif event.key == K_LEFT:
                        self.room.moveleft()
                        self.room.direction = "right"
                        self.player.direction = self.player.LEFT 
                    elif event.key == K_UP:
                        self.roomnumber = self.room.exit(self)
                        self.chooseroom(self.roomnumber,self.font)

			if self.room.collideropes(self.player):
				print "Collision with Rope"
				climbingover = 0
        			while climbingover == 0:
  	          		           sleep(0.01)
         				   for event in pygame.event.get():
                				if event.type == QUIT:
                    					return
                				elif event.type == KEYDOWN:
            	    					self.keydown = 1
                    					# self.player 1 key controls
                   					if event.key == K_UP: 
								self.room.moveup()
            							self.room.update(self.player)
            							self.room.draw(self.screen,self.player,self.taskbar)
            							self.taskbar.draw(self)
            							self.player.update(self.room)
	    							self.player.draw(self.screen,self.room)
            							self.bgoverlay.draw(self.screen)
            
            							pygame.display.update()
            							self.screen.blit(blankimage, (0,0))
							elif event.key == K_DOWN:
								self.room.movedown()
            							self.room.update(self.player)
            							self.room.draw(self.screen,self.player,self.taskbar)
            							self.taskbar.draw(self)
            							self.player.update(self.room)
	    							self.player.draw(self.screen,self.room)
            							self.bgoverlay.draw(self.screen)
            
            							pygame.display.update()
            							self.screen.blit(blankimage, (0,0))
					   	if not self.room.collideropes(self.player):
							climbingover = 1
	
                        ####if self.roomnumber == 0:
                        elif self.room.fall(self.player) == 2:
				self.player.jump(self.room)    
 
            if self.room.collide(self.player) == 1 or self.player.hitpoints <= 0:
		print "game over!"
		exit 
            self.room.update(self.player)
            self.room.fall(self.player)
            self.room.draw(self.screen,self.player,self.taskbar)
            self.taskbar.draw(self)
            self.player.update(self.room)
	    self.player.draw(self.screen,self.room)
            self.bgoverlay.draw(self.screen)
            
            pygame.display.update()
            self.screen.blit(blankimage, (0,0))
            
    def setxy(self,xx,yy):
        self.x = xx
        self.y = yy

    def setplayerxy(self,xx,yy):
        self.player.x = xx
        self.player.y = yy

    # NOTE: set x y in maproom1 and Game() will set it with game.x (self.x) etc. 
    def chooseroom(self, roomnumber,font):
        if (roomnumber == 0):
            return
        # Moon woods
        elif (roomnumber == 1):
            self.talker = None
            self.room = Maproom1(self.x,self.y)
            
if __name__ == "__main__":
    foo = Game()



